<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedTypedPrice3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedTypedPrice3 extends AbstractStructArrayBase
{
    /**
     * The Infant
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedTypedPrice[]
     */
    public $Infant;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedTypedPrice3
     * @uses ArrayOfJPSOAP_OrderedTypedPrice3::setInfant()
     * @param \StructType\JPSOAP_OrderedTypedPrice[] $infant
     */
    public function __construct(array $infant = array())
    {
        $this
            ->setInfant($infant);
    }
    /**
     * Get Infant value
     * @return \StructType\JPSOAP_OrderedTypedPrice[]|null
     */
    public function getInfant()
    {
        return $this->Infant;
    }
    /**
     * Set Infant value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedTypedPrice[] $infant
     * @return \ArrayType\ArrayOfJPSOAP_OrderedTypedPrice3
     */
    public function setInfant(array $infant = array())
    {
        foreach ($infant as $arrayOfJPSOAP_OrderedTypedPrice3InfantItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedTypedPrice3InfantItem instanceof \StructType\JPSOAP_OrderedTypedPrice) {
                throw new \InvalidArgumentException(sprintf('The Infant property can only contain items of \StructType\JPSOAP_OrderedTypedPrice, "%s" given', is_object($arrayOfJPSOAP_OrderedTypedPrice3InfantItem) ? get_class($arrayOfJPSOAP_OrderedTypedPrice3InfantItem) : gettype($arrayOfJPSOAP_OrderedTypedPrice3InfantItem)), __LINE__);
            }
        }
        $this->Infant = $infant;
        return $this;
    }
    /**
     * Add item to Infant value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedTypedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedTypedPrice3
     */
    public function addToInfant(\StructType\JPSOAP_OrderedTypedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedTypedPrice) {
            throw new \InvalidArgumentException(sprintf('The Infant property can only contain items of \StructType\JPSOAP_OrderedTypedPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Infant[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Infant
     */
    public function getAttributeName()
    {
        return 'Infant';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_OrderedTypedPrice3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
